#ifndef EFL_GENERATED_ECORE_ANIMATOR_HH
#define EFL_GENERATED_ECORE_ANIMATOR_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_animator.eo.h"
}


struct ecore_animator
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_animator(Eo* eo)
      : efl::eo::base(eo)
   {}

   ecore_animator(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_animator(_c0(_p))
   {}

   /// @param runtime 
   /// @param func 
   /// @param data 
   ///
   ecore_animator(double runtime, Ecore_Timeline_Cb func, const void * data, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_animator(_c1(runtime, func, data, _p))
   {}

   /// @param func 
   /// @param data 
   ///
   ecore_animator(Ecore_Task_Cb func, const void * data, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_animator(_c2(func, data, _p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_animator(ecore_animator const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~ecore_animator() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_ANIMATOR_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_ANIMATOR_CLASS, _p._eo_raw, eo_constructor());
   }

   static Eo* _c1(double runtime, Ecore_Timeline_Cb func, const void * data, efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_ANIMATOR_CLASS, _p._eo_raw, ecore_animator_timeline_constructor(runtime, func, data));
   }

   static Eo* _c2(Ecore_Task_Cb func, const void * data, efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_ANIMATOR_CLASS, _p._eo_raw, ecore_animator_constructor(func, data));
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_animator >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_animator >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_animator>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::ecore_animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_animator, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_animator, ::std::tuple<double, Ecore_Timeline_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_animator_timeline_constructor(args.get<0>(), args.get<1>(), args.get<2>()));
}

inline void
call_constructor(tag< ::ecore_animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_animator, ::std::tuple<Ecore_Task_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_animator_constructor(args.get<0>(), args.get<1>()));
}

template<>
struct extension_inheritance< ::ecore_animator>
{
   template <typename T>
   struct type
   {
      operator ::ecore_animator() const
      {
         return ::ecore_animator(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_animator>)
{
   return (ECORE_ANIMATOR_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_ANIMATOR_HH

